VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_color_pickover_popcorn"
   ClientHeight    =   5205
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6255
   LinkTopic       =   "Form1"
   ScaleHeight     =   5205
   ScaleWidth      =   6255
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtH 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   360
      TabIndex        =   5
      Text            =   "0.05"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox txtIterationsPerPixel 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2040
      TabIndex        =   4
      Text            =   "100"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox txtDx 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   3240
      TabIndex        =   3
      Text            =   "10"
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdPlotAll 
      Caption         =   "Plot All"
      Default         =   -1  'True
      Height          =   375
      Left            =   4080
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   5160
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.PictureBox picCanvas 
      BackColor       =   &H00000000&
      Height          =   4500
      Left            =   120
      ScaleHeight     =   296
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   396
      TabIndex        =   0
      Top             =   600
      Width           =   6000
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "h:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   135
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Iterations:"
      Height          =   195
      Index           =   1
      Left            =   1320
      TabIndex        =   7
      Top             =   120
      Width           =   690
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "dx:"
      Height          =   195
      Index           =   2
      Left            =   3000
      TabIndex        =   6
      Top             =   120
      Width           =   210
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Coordinate conversion constants.
Private Const Wxmin  As Single = -4#
Private Const Wxmax  As Single = 4#
Private Const Wymin  As Single = -3#
Private Const Wymax  As Single = 3#
Private Const Wwid  As Single = (Wxmax - Wxmin)
Private Const Whgt  As Single = (Wymax - Wymin)
Private Const Dxmin  As Single = 0
Private Const Dxmax  As Single = 400
Private Const Dymin  As Single = 0
Private Const Dymax  As Single = 300
Private Const Dwid  As Single = (Dxmax - Dxmin)
Private Const Dhgt  As Single = (Dymax - Dymin)

' Red, green, or blue?
Private Const RgbRed As Integer = 0
Private Const RgbGreen As Integer = 1
Private Const RgbBlue As Integer = 2
Private RgbType As Integer

' Parameters
Private IterationsPerPixel As Integer
Private h As Single

Private Sub Form_Load()
    picCanvas.AutoRedraw = True
    RgbType = RgbRed
End Sub

' Plot a bunch of points.
Private Sub cmdPlotAll_Click()
Dim dx As Integer
Dim X As Integer
Dim Y As Integer
    
    GetParameters

    ' Clear.
    picCanvas.Cls

    ' Plot a series for each point.
    dx = CInt(txtDx.Text)
    For X = 0 To picCanvas.ScaleWidth - 1 Step dx
        For Y = 0 To picCanvas.ScaleHeight - 1 Step dx
            PlotPoints picCanvas, h, X, Y, IterationsPerPixel, RgbType
            RgbType = (RgbType + 1) Mod 3
        Next Y
        picCanvas.Refresh
    Next X
    picCanvas.Refresh
End Sub

' Get the parameters.
Private Sub GetParameters()
    IterationsPerPixel = CInt(txtIterationsPerPixel.Text)
    h = CSng(txtH.Text)
End Sub

' Plot points for a pixel using the equations:
'      x(n + 1) = x(n) - h * Sin(y(n) + Tan(3 * y(n)))
'      y(n + 1) = y(n) - h * Sin(x(n) + Tan(3 * x(n)))
Private Sub PlotPoints(ByVal pic As PictureBox, ByVal h As Single, ByVal pix_x As Integer, ByVal pix_y As Integer, ByVal iterations As Integer, ByVal rgb_type As Integer)
Dim wx As Single
Dim wy As Single
Dim new_x As Single
Dim new_y As Single
Dim i As Integer
Dim r As Byte
Dim g As Byte
Dim b As Byte

    ' Convert the first point to world coordinates.
    DeviceToWorld pix_x, pix_y, wx, wy

    ' Plot points.
    pic.PSet (pix_x, pix_y), vbBlue
    
    For i = 1 To iterations
        new_x = CSng(wx - h * Math.Sin(wy + Math.Tan(3 * wy)))
        new_y = CSng(wy - h * Math.Sin(wx + Math.Tan(3 * wx)))
        wx = new_x
        wy = new_y

        WorldToDevice wx, wy, pix_x, pix_y
        If (pix_x >= 0 And pix_x < picCanvas.ScaleWidth And _
            pix_y >= 0 And pix_y < picCanvas.ScaleHeight) _
        Then
            ' Get the pixel's RGB color components.
            UnRGB picCanvas.Point(pix_x, pix_y), r, g, b
            
            Select Case rgb_type
                Case RgbRed
                    r = (r + 255) / 2
                Case RgbGreen
                    g = (g + 255) / 2
                Case RgbBlue
                    b = (b + 255) / 2
            End Select
            
            picCanvas.PSet (pix_x, pix_y), RGB(r, g, b)
        End If
    Next i
End Sub

' Convert between world and device coordinates.
Private Sub WorldToDevice(ByVal wx As Single, ByVal wy As Single, ByRef dx As Integer, ByRef dy As Integer)
    dx = CInt(Dxmin + Dwid * (wx - Wxmin) / Wwid)
    dy = CInt(Dymin + Dhgt * (wy - Wymin) / Whgt)
End Sub
Private Sub DeviceToWorld(ByVal dx As Integer, ByVal dy As Integer, ByRef wx As Single, ByRef wy As Single)
    wx = Wxmin + Wwid * (dx - Dxmin) / Dwid
    wy = Wymin + Whgt * (dy - Dymin) / Dhgt
End Sub

' Clear.
Private Sub cmdClear_Click()
    picCanvas.Cls
End Sub

' Plot points for the clicked pixel.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    GetParameters

    ' Plot the point's series.
    PlotPoints picCanvas, h, X, Y, IterationsPerPixel, RgbType
    RgbType = (RgbType + 1) Mod 3
    picCanvas.Refresh
End Sub

' Return a color's red, green, and blue components.
Private Sub UnRGB(ByRef color As OLE_COLOR, ByRef r As Byte, ByRef g As Byte, ByRef b As Byte)
    r = color And &HFF&
    g = (color And &HFF00&) \ &H100&
    b = (color And &HFF0000) \ &H10000
End Sub

